#!/usr/bin/perl

# make-gtkrc.pl -- Build gtkrc files from templates
# $Id: make-gtkrc.pl,v 1.2 2001/01/11 19:31:22 jsh Exp $

# make-gtkrc.pl SUBST-FILE... < INPUT > OUTPUT


# Default parameter values (from Eazel-Teal)

my %substs = (
  focus_color		=> '"#508083"',
  recolor_gradient	=> '"#000000", "#4a7d84", "#ffffff"',
  menuitem_gradient	=> 'vertical: "#52878a", "#184446", "#52878a"',
  insensitive_colors	=> '"#5c63a3", "#cecfce"',
);
	      

# Read all substitutions into the above hash

foreach my $subst_file (@ARGV) {

    open (SUBST, $subst_file) or die "Can't open $subst_file for input: $!";

    while (<SUBST>) {
	# skip blank lines and comments
	next if /^#/;
	next if /^\s*$/;
	chop;

	if (! /^(\S+?)\s+(.*)$/) {
	    die "Malformed substitution: $_";
	}

	$substs{$1} = $2;
    }

    close SUBST;
}


# Then run through STDIN applying them..

print "# gtkrc generated automatically by make-gtkrc.pl\n\n";

while (<STDIN>) {
    while (/\@([a-zA-Z0-9_]+)\@/) {
	my $word = $1;
	if ($word eq "") {
	    s/\@\@/\@/;
	} else {
	    defined $substs{$word} or die "Undefined substitution: $word";
	    s/\@$word\@/$substs{$word}/;
	}
    }
    print $_;
}

# End of make-gtkrc.pl
